package vfl;

import java.awt.*;
import java.util.*;


public class SeaScape {

    private int width;
    private int height;
    private int depthOfWater;
    private Set seaObjects;
    
    
    public SeaScape (int width, int height) {
    	this.width = width;
    	this.height = height;
    	seaObjects = new HashSet();   	
    } 
	
	public void addSeaObject (SeaObject a) {
		seaObjects.add(a);
	} 
	
	
	public void removeSeaObject(SeaObject a) {
		seaObjects.remove(a);	
	}
		
	public void removeAll() {
		seaObjects.clear();
	}	
		
		
	public Set getSeaObjects() {
	   return seaObjects;	
	}
	
	public int getWidth () {
		return width;
	}
	
	public int getHeight() {
		return height;
	}
	
	public void moveTo (double time) {
      Iterator so = seaObjects.iterator();
      while(so.hasNext()) {
      	SeaObject oso = (SeaObject)so.next();
      	oso.moveTo(time);
      }
		
	}

	public void move (double time) {
      Iterator so = seaObjects.iterator();
      while(so.hasNext()) {
      	SeaObject oso = (SeaObject)so.next();
      	oso.move(time);
      }
		
	}

	
	public void paint(Graphics g) {
      Iterator so = seaObjects.iterator();
      while(so.hasNext()) {
      	SeaObject oso = (SeaObject)so.next();
      	oso.paint(g);	
      }

	}
		
	
}

