package vfl;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import JSci.maths.ExtraMath;
import java.util.*;
import com.stevesoft.pat.*;


public class LectureDicParse extends JFrame {
    private final String webhost = "http://web.mit.edu/fluids-modules/www/potential_flows/WavesDef/DefWeb/";
    private final File initialDB = new File ("/afs/athena.mit.edu/course/other/fluids-modules/www/potential_flows/WavesDef/DefWeb");
    private final String localtmp = "/tmp/";
    File file;
    
    JTextField ss;
    JTextField comment;
    JButton search;
    
    JEditorPane answerbox;
    Container main;
    
    boolean htmlInput = false;
    String acpt = "pt";
    String acht = "ht";
    public LectureDicParse() {
        
  /*
        getRootPane().putClientProperty("defeatSystemEventQueueCheck",
        Boolean.TRUE);
   
    }
   
    public void init() {
   
   */
        //main = this;
        super("Input Definition Service");
        JMenuBar menuBar = new JMenuBar();
        //menuBar.setBorder(BorderFactory.createRaisedBevelBorder());
        
        setJMenuBar(menuBar);
        JMenu menu;
        JMenuItem menuItem;
        menu = new JMenu("File");
        menuBar.add(menu);
        
        menuItem = new JMenuItem("Set DB Directory");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser(initialDB);
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                try {
                    if (returnValue == JFileChooser.APPROVE_OPTION) {
                        file = fileChooser.getSelectedFile();
                        comment.setText("Set " + file.getAbsolutePath() + " as DB directory");
                    }
                } catch(Exception r) {}
            }
        });
        menu.add(menuItem);
      
        menuItem = new JMenuItem("Load HTML/LaTeX File");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser(initialDB);
                int returnValue = fileChooser.showOpenDialog(null);
                try {
                    if (returnValue == JFileChooser.APPROVE_OPTION) {
                        File htmlfile = fileChooser.getSelectedFile();
                        FileReader in = new FileReader(htmlfile);
        				StringWriter out = new StringWriter();
        				int c;
        				while ((c = in.read()) != -1)
           				out.write(c);
        				in.close();
        				String pr = out.getBuffer().toString();;
        				out.close();
        				answerbox.setText(pr);
                        comment.setText("Got " + htmlfile.getAbsolutePath() + "for LaTeX editing");
                    }
                } catch(Exception r) {}
            }
        });
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Load'n'Convert LaTeX {Itemize} File");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser(initialDB);
                int returnValue = fileChooser.showOpenDialog(null);
                try {
                    if (returnValue == JFileChooser.APPROVE_OPTION) {
                        File htmlfile = fileChooser.getSelectedFile();
                        FileReader in = new FileReader(htmlfile);
        		StringWriter out = new StringWriter();
        		int c;
        		while ((c = in.read()) != -1)
           		    out.write(c);
        		in.close();
        		String pr = out.getBuffer().toString();;
        		out.close();
                        
        	        RegexTokenizer rgt = new RegexTokenizer(pr,"\\\\item");	
                        String outt = "";
			String outts = "";
                        String def = "";
                        String neat ="";
                        rgt.nextToken();
                        while (rgt.hasMoreTokens()) {
			    outt = rgt.nextToken();
                            outts = ( new RegexTokenizer(outt,"\\.").nextToken());
                            def = (outt.substring(outts.length()+1)).trim();
                            outts = outts.trim();
                     try {
			String keyword = outts; 
                        StringTokenizer st = new StringTokenizer(keyword);
			String texfile = "";
                        while (st.hasMoreTokens()) {
			    texfile += st.nextToken();
			} 

                        File lw = new File(file.getAbsolutePath() + File.separator + texfile +".tex");
			FileWriter sstream = new FileWriter(lw);
			sstream.write(def);
                        sstream.flush();
			sstream.close();
                        
                        Runtime rt = Runtime.getRuntime();
                        //rt.exec("add infoagents");
                        //rt.exec("cd " + file.getAbsolutePath());  
                        String cmd = "latex2html -no_math -split 0 -info 0 -no_navigation "
                                      + "-dir " + localtmp + texfile
                                      + " " + file.getAbsolutePath() + File.separator + texfile +".tex"; 
                        rt.exec(cmd).waitFor();
			
			cmd = "mkdir " +  file.getAbsolutePath() + File.separator + texfile;
                        rt.exec(cmd).waitFor();

			cmd = "cp -r "+ localtmp + texfile + File.separator + "* " 
                                      + file.getAbsolutePath() + File.separator + texfile; 
                        System.out.println(cmd);
                        rt.exec(cmd).waitFor();

			// file.getAbsolutePath() + File.separator + texfile
                        char f = keyword.charAt(0);
                        File dbc = new File(file.getAbsolutePath() + File.separator + f + ".tdb");
			if (dbc.canRead()) {
			    FileInputStream istream = new FileInputStream(dbc);
			    ObjectInputStream is = new ObjectInputStream(istream);
			    Hashtable a = (Hashtable) is.readObject();
			    istream.close();
			    a.put(keyword,"latexlink " + webhost+"/"+texfile+"/"+texfile+".html");
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			} else {
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    Hashtable a = (Hashtable) new Hashtable();
			    a.put(keyword,"latexlink " + webhost+"/"+texfile+"/"+texfile+".html");
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			}                        
                        
                    } catch (Exception a) {
			comment.setText("Problem: " + a.toString());
		    }
		    } 
                       
                        
			// comment.setText("Got " + htmlfile.getAbsolutePath() + " and Itemized It");
                    }
                } catch(Exception r) {}
            }
        });
        menu.add(menuItem);
        
        main = getContentPane();
        search = new JButton("Input");
        search.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String keyword = ss.getText();
                char f = '%';
                if (htmlInput) {
		    try {
			f = keyword.charAt(0);
			File dbc = new File(file.getAbsolutePath() + File.separator + f + ".tdb");
			if (dbc.canRead()) {
			    FileInputStream istream = new FileInputStream(dbc);
			    ObjectInputStream is = new ObjectInputStream(istream);
			    Hashtable a = (Hashtable) is.readObject();
			    istream.close();
			    a.put(keyword,answerbox.getText());
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			} else {
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    Hashtable a = (Hashtable) new Hashtable();
			    a.put(keyword,answerbox.getText());
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			}
		    }
		    catch (Exception exp) {
			if (f == '%') {
			    comment.setText("Problem: Enter term please");
			}else
			    comment.setText("Problem " + exp);
                    
		    }
                } else {
                    
		    try {
                        StringTokenizer st = new StringTokenizer(keyword);
			String texfile = "";
                        while (st.hasMoreTokens()) {
			    texfile += st.nextToken();
			} 

                        File lw = new File(file.getAbsolutePath() + File.separator + texfile +".tex");
			FileWriter sstream = new FileWriter(lw);
			sstream.write(answerbox.getText());
                        sstream.flush();
			sstream.close();
                        
                        Runtime rt = Runtime.getRuntime();
                        //rt.exec("add infoagents");
                        rt.exec("cd " + file.getAbsolutePath());  
                        String cmd = "latex2html -no_math -split 0 -info 0 -no_navigation "
                                      + "-dir " + file.getAbsolutePath() + File.separator + texfile
                                      + " " + file.getAbsolutePath() + File.separator + texfile +".tex"; 
                        rt.exec(cmd);

                        f = keyword.charAt(0);
                        File dbc = new File(file.getAbsolutePath() + File.separator + f + ".tdb");
			if (dbc.canRead()) {
			    FileInputStream istream = new FileInputStream(dbc);
			    ObjectInputStream is = new ObjectInputStream(istream);
			    Hashtable a = (Hashtable) is.readObject();
			    istream.close();
			    a.put(keyword,"latexlink " + webhost+"/"+texfile+"/"+texfile+".html");
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			} else {
			    FileOutputStream ostream = new FileOutputStream(dbc);
			    ObjectOutputStream p = new ObjectOutputStream(ostream);
			    Hashtable a = (Hashtable) new Hashtable();
			    a.put(keyword,"latexlink " + webhost+"/"+texfile+"/"+texfile+".html");
			    p.writeObject(a);
			    p.flush();
			    ostream.close();
			    comment.setText("The word '" + keyword + "' and its definition saved");
                        
			}                        
                        
                    } catch (Exception a) {
			comment.setText("Problem: " + a.toString());
		    }
		}
            }
        });
        
        ss = new JTextField();
        ss.setColumns(30);
        
        JRadioButton plainDefButton = new JRadioButton("LaTeX");
        plainDefButton.setActionCommand(acpt);
        plainDefButton.setSelected(true);
        
        JRadioButton htmlButton = new JRadioButton("HTML");
        htmlButton.setActionCommand(acht);
        
        ButtonGroup group = new ButtonGroup();
        group.add(plainDefButton);
        group.add(htmlButton);
        
        plainDefButton.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                htmlInput=false;
            }
        });
        
        htmlButton.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                htmlInput=true;
            }
        });
        
        
        
        answerbox = new JEditorPane();
        answerbox.setEditable(true);
        JScrollPane editorScrollPane = new JScrollPane(answerbox);
        editorScrollPane.setPreferredSize(new Dimension(600,200));
        editorScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        JPanel top = new JPanel();
        JPanel center = new JPanel();
        center.setLayout(new FlowLayout());
        center.add(ss);
        center.add(plainDefButton);
        center.add(htmlButton);
        center.add(search);
        JPanel west = new JPanel();
        JPanel east = new JPanel();
        JPanel north = new JPanel();
        JPanel south = new JPanel();
        top.setLayout(new BorderLayout());
        top.add(west, BorderLayout.EAST);
        top.add(east, BorderLayout.WEST);
        top.add(north, BorderLayout.NORTH);
        top.add(south, BorderLayout.SOUTH);
        top.add(center, BorderLayout.CENTER);
        
        JPanel bottom = new JPanel();
        bottom.setLayout(new BorderLayout());
        bottom.add(new JPanel(), BorderLayout.EAST);
        bottom.add(new JPanel(), BorderLayout.WEST);
        bottom.add(new JPanel(), BorderLayout.NORTH);
        comment = new JTextField();
        comment.setEditable(false);
        comment.setBorder(BorderFactory.createLoweredBevelBorder());
        
        bottom.add(comment, BorderLayout.SOUTH);
        bottom.add(editorScrollPane, BorderLayout.CENTER);
        
        
        top.setMinimumSize(top.getPreferredSize());
        bottom.setMinimumSize(bottom.getPreferredSize());
        
        JSplitPane jsp = new JSplitPane(JSplitPane.VERTICAL_SPLIT,top,bottom);
        //jsp.setBorder(BorderFactory.createRaisedBevelBorder());
        main.add(jsp);
        main.setBackground(Color.black);
        
        
    }
/*
    public void start() {
 
    }
 */
    public static void main(String[] args) {
        LectureDicParse frame  = new LectureDicParse();
        frame.setResizable(false);
        frame.pack();

        frame.setVisible(true);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }
    
    
}

