package vfl;

import JSci.maths.ExtraMath;
import java.awt.*;
import java.util.*;
import java.awt.geom.*;

public class VelocityVector implements SeaObject {
    private int cx;
    private int cy;
    private double ox;
    private double oy;
    private double amp;
    private double gravity;
    private double k;
    private double w;
    private double height;
    private double time;
    private int ex;
    private int ey;
    private double xfactor;
    private double yfactor;
    private double ystart;
    private double[] wavey;
    public VelocityVector(double cx, double cy, double amp, double gravity, double k,
    double omega, double height, double time,
    double xfactor, double yfactor, double xstart, double ystart,double[] wavey) {
        
        this.wavey = wavey;
        this.ox = cx;
        this.oy = cy;
        this.cx = (int)Math.round((cx-xstart)*xfactor);
        this.cy = (int)Math.round((cy-ystart)*yfactor);
        this.amp = amp;
        this.gravity = gravity;
        this.k = k;
        this.w = omega;
        this.height = height;
        this.time = time;
        this.xfactor = xfactor;
        this.yfactor = yfactor;
        this.ystart =ystart* yfactor;
        
        this.ex = this.cx + (int)Math.round((amp * gravity * k / w * ExtraMath.cosh(k * (-oy+height)) * Math.cos((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * xfactor);
        this.ey = this.cy + (int)Math.round(-(amp * gravity * k / w * ExtraMath.sinh(k * (-oy+height)) * Math.sin((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * yfactor);
        
        
        
    }
    public void move(double t) {
        this.time = this.time + t;
        
        this.ex = cx + (int)Math.round((amp * gravity * k / w * ExtraMath.cosh(k * (-oy+height)) * Math.cos((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * xfactor);
        this.ey = cy + (int)Math.round(-(amp * gravity * k / w * ExtraMath.sinh(k * (-oy+height)) * Math.sin((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * yfactor);
        
        
    }
    
    public void moveTo(double t) {
        this.time = t;
        
        this.ex = cx + (int)Math.round((amp * gravity * k / w * ExtraMath.cosh(k * (-oy+height)) * Math.cos((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * xfactor);
        this.ey = cy + (int)Math.round(-(amp * gravity * k / w * ExtraMath.sinh(k * (-oy+height)) * Math.sin((k*ox)-(w*time)) /
        ExtraMath.cosh(k*height)) * yfactor);
    }
    
    public void paint(Graphics g) {
        
        g.setColor(Color.magenta);
        if (((-wavey[cx]-ystart) <= cy) && (cy < ( -ystart + (height*yfactor)))){
            g.drawLine(cx,cy,ex,ey);
            double yt = cy-ey;
            double xt = ex-cx;
            if (Math.sqrt((yt*yt)+(xt*xt)) >=1) {
                double angle = Math.atan(yt/xt);
                if ((xt < 0) && (yt >= 0))angle+=Math.PI;
                else if ((xt < 0) && (yt < 0)) angle +=Math.PI;
                double flang = angle + (Math.PI - (Math.PI/4));
                g.drawLine(ex,ey,(int)Math.round( ex + 4*Math.cos(flang)),(int)Math.round(ey - 4*Math.sin(flang)));
                double slang = angle + (Math.PI + (Math.PI/4));
                g.drawLine(ex,ey,(int)Math.round( ex + 4*Math.cos(slang)),(int)Math.round(ey - 4*Math.sin(slang)));
                
            }
            
        }
    }
    
}